use crate::{
    app::session::SessionToken,
    util::pack::{pack_u8, pack_u16},
};

use super::Packet;

#[derive(Clone)]
pub struct PacketSessionCreate {

}
impl PacketSessionCreate {
    pub fn new() -> Self
    {
        Self { }
    }
}
impl Packet for PacketSessionCreate {
    type Data = Self;

    fn decode(_data:&Vec<u8>, _index:&mut usize) -> Result<Self::Data, ()>
    {
        Ok(Self::new())
    }
}


#[derive(Clone)]
pub struct PacketSessionCreateResponse {
    pub status:u16,
    pub token:SessionToken,
    pub mode:u8,
}
impl PacketSessionCreateResponse {
    pub fn new() -> Self
    {
        Self {
            status:0,
            token:SessionToken::default(),
            mode:0,
        }
    }
}
impl Packet for PacketSessionCreateResponse {
    type Data = Self;

    fn encode(&self) -> Vec<u8>
    {
        [
            pack_u16(self.status),
            pack_u8(self.mode),
            self.token.to_vec(),
        ].concat()
    }
}
